# Flask Imports #
from src.e_Infra.b_Builders.FlaskBuilder import *

# Service Layer Imports #
from src.b_Application.b_Service.a_Domain.SetTypeTableService import *

# Decorator Imports #
from src.e_Infra.f_Decorators.JsonLoadsDecorator import *


# /set_type_table route #
@app_handler.route('/settypetable', methods=['GET'])
def set_type_table_route_get():
    # Routing request to /set_type_table GET method #
    if request.method == 'GET':
        result = get_set_type_table_set(
            request.args.to_dict(), {'HTTP_SELECT': request.environ.get('HTTP_SELECT'),
                                     'HTTP_ORDERBY': request.environ.get('HTTP_ORDERBY'),
                                     'HTTP_LIMIT': request.environ.get('HTTP_LIMIT'),
                                     'HTTP_PAGE': request.environ.get('HTTP_PAGE')}
        )
        return result


# /set_type_table route #
@app_handler.route('/settypetable', methods=['POST', 'PATCH', 'PUT'])
def set_type_table_route_post_patch_put():
    # Routing request to /set_type_table POST method #
    if request.method == 'POST':
        result = post_set_type_table_set(request.json)
        return result
    # Routing request to /set_type_table PATCH method #
    if request.method == 'PATCH':
        result = patch_set_type_table_set(request.json)
        return result
    if request.method == 'PUT':
        result = put_set_type_table_set(request.json)
        return result


# /set_type_table route #
@app_handler.route('/settypetable', methods=['DELETE'])
def set_type_table_route_delete_by_full_match():
    # Routing request to /set_type_table DELETE method #
    if request.method == 'DELETE':
        result = delete_set_type_table_by_full_match(request.json)
        return result


# /set_type_table/{id} route #
@app_handler.route('/settypetable/<id_set_type_table>', methods=['GET'])
def set_type_table_route_get_by_id(id_set_type_table):
    # Routing request to /set_type_table/{id} GET method #
    if request.method == 'GET':
        result = get_set_type_table_by_id(
            [id_set_type_table], request.args.to_dict(
            ), {'HTTP_SELECT': request.environ.get('HTTP_SELECT')}
        )
        return result


# /set_type_table/{id} route #
@app_handler.route('/settypetable/<id_set_type_table>', methods=['DELETE'])
def set_type_table_route_delete_by_id(id_set_type_table):
    # Routing request to /set_type_table/{id} DELETE method #
    if request.method == 'DELETE':
        result = delete_set_type_table_by_id([id_set_type_table])
        return result
